import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.Iterator;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;


public class MainView extends JFrame implements ActionListener {
  private static final long serialVersionUID = 1L;
  private JPanel mainpane = new JPanel();
  private JPanel buttonpane = new JPanel();
  private JPanel boxpane = new JPanel();
  private JPanel bottompane = new JPanel();
  private JButton openButton = new JButton("Datei laden");
  private JButton uploadButton = new JButton("Aufspielen");
  private JLabel fileLabel = new JLabel("Keine Datei geladen..");
  private JLabel portLabel = new JLabel("Com-Port");
  private JComboBox portBox = new JComboBox();
  final JFileChooser fc = new JFileChooser();
  
  public MainView(){
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setTitle("Arduino-Loader");
    this.setMinimumSize(new Dimension(250,150));
    setComponents();
    this.setLocationRelativeTo(null);
    this.pack();
  }
  
  //Sets the components to the JFrame
  private void setComponents(){
    fc.addChoosableFileFilter(new HexFilter());
    GridLayout gl = new GridLayout(0,1);
    gl.setVgap(10);
    Border b =BorderFactory.createEtchedBorder(EtchedBorder.LOWERED);
    bottompane.setBorder(b);
    boxpane.setBorder(b);
    buttonpane.setLayout(gl);
    boxpane.setLayout(new BoxLayout(boxpane, BoxLayout.Y_AXIS));
    mainpane.setLayout(new FlowLayout());
    this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));
    this.getContentPane().add(mainpane);
    this.getContentPane().add(bottompane);
    bottompane.add(fileLabel);
    buttonpane.add(openButton);
    buttonpane.add(uploadButton);
    boxpane.add(portLabel);
    boxpane.add(portBox);
    mainpane.add(buttonpane);
    mainpane.add(boxpane);
    uploadButton.setEnabled(false);
    PortCommunicator pc = new PortCommunicator();
    Iterator<String> ports = pc.getActivePorts().iterator();
    while (ports.hasNext()){
      String p = ports.next();
      portBox.addItem(p);
    }
    openButton.addActionListener(this);
    uploadButton.addActionListener(this);
    
  }

  @Override
  public void actionPerformed(ActionEvent arg0) {
    if (arg0.getSource()==openButton){
      int returnVal = fc.showOpenDialog(this);
      if (returnVal == JFileChooser.APPROVE_OPTION) {
        fileLabel.setText(fc.getSelectedFile().getName()+" geladen");
        uploadButton.setEnabled(true);
      }
    }
    
    if (arg0.getSource()==uploadButton){
      Loader l = new Loader((portBox.getSelectedItem()).toString(),fc.getSelectedFile().getAbsolutePath());
      try {
        l.execute();
      } catch (IOException e) {
          System.out.print(e.toString());
      }
    }
    
  }

}
