import gnu.io.CommPortIdentifier;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

/** List all the ports available on the local machine. **/
public class PortCommunicator {
  private List<String> activePorts;

  public PortCommunicator(){
    activePorts = listports(); 
  }

  public List<String> getActivePorts() {
    return activePorts;
  }

  private List<String> listports(){
    List<String> res = new ArrayList<String>();
    Enumeration port_list = CommPortIdentifier.getPortIdentifiers();
    while (port_list.hasMoreElements()) {
      CommPortIdentifier port_id = (CommPortIdentifier)port_list.nextElement();
      if (port_id.getPortType() == CommPortIdentifier.PORT_SERIAL) {
        res.add(port_id.getName());
      }
    }
    return res;
  }
  
}